<?php
/*
 * EhPortal is a ported version of SimplePortal 2.3.7 (Copyright (c) 2014 SimplePortal Team.)
 * This software is in no way affiliated with the original developers
 * EhPortal ~ Copyright (c) 2024 WebDev (https://web-develop.ca)
 * Distributed under the BSD 2-Clause License (https://opensource.org/licenses/BSD-2-Clause)
*/

if (!defined('SMF'))
	die('Hacking attempt...');

function sportal_admin_header_main()
{
	global $context, $txt, $sourcedir;

	if (!allowedTo('sp_admin'))
		isAllowedTo('sp_manage_blocks');

	require_once($sourcedir . '/Subs-PortalAdmin.php');
	sp_smf_version();

	loadTemplate('PortalAdminHeader');

	$subActions = array(
		'edit' => 'sportal_admin_header_edit',
	);

	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'edit';

	$context['sub_action'] = $_REQUEST['sa'];

	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title' => $txt['sp_admin_header_title'],
		'help' => 'sp_HeaderArea',
		'description' => $txt['sp_admin_header_desc'],
		'tabs' => array(
			'list' => array(
			),
			'add' => array(
			),
		),
	);

	$subActions[$_REQUEST['sa']]();
}


function sportal_admin_header_edit()
{
	global $txt, $context, $modSettings, $smcFunc, $sourcedir, $options;

	require_once($sourcedir . '/Subs-Editor.php');
	require_once($sourcedir . '/Subs-Post.php');

	$context['SPortal']['is_new'] = true;
	$context['SPortal']['header'] = array(
		'id' => 1,
		'body' => '',
		'ignore' => '',
		'status' => 1,
	);

	if (isset($_POST['submit']))
	{
		$pagetype = 'html';
		if (isset($_POST['content']) && !empty($pagetype)) {
			$str = trim(htmlspecialchars_decode($_POST['content'], ENT_QUOTES));
			$str = mb_strtolower($str);
			$_POST['content'] = substr($str, 0, strlen('<?php')) == '<?php' ? substr($_POST['content'], strlen('<?php')) : $_POST['content'];
			$_POST['content'] = substr($str, -2) == '?>' ? substr($_POST['content'], 0, -2) : $_POST['content'];
			$_POST['content'] = trim($_POST['content']);
		}
		if (isset($_POST['content']) && !empty($modSettings['sp_php_html_escape_filter']) && !empty($pagetype)) {
			$content = preg_replace("~\\\\{1,}~u", "\\",$_POST['content']);
			$content = preg_replace("~\\\\{1,}'~u", "'", $content);
			// only preserve literal new lines & tabs
			$content = preg_replace("~(\\\\r\\\\n|\\\\r|\\\\n)~u", " ", $content);
			$_POST['content'] = str_replace("\\t", "&ensp;", $content);
		}

	}

	if (!empty($_POST['submit']))
	{
		checkSession();

		$result = $smcFunc['db_query']('','
			SELECT id_head
			FROM {db_prefix}sp_website_header
			WHERE id_head = {int:current}
			LIMIT 1',
			array(
				'limit' => 1,
				'current' => 1,
			)
		);
		list ($has_duplicate) = $smcFunc['db_fetch_row']($result);
		$smcFunc['db_free_result']($result);

		$fields = array(
			'id_head' => 'int',
			'body' => 'string',
			'ignores' => 'string',
			'status' => 'int',
		);

		$page_info = array(
			'id' => 1,
			'body' => $smcFunc['htmlspecialchars']($_POST['content'], ENT_QUOTES),
			'ignores' => $smcFunc['htmlspecialchars']($_POST['ignores'], ENT_QUOTES),
			'status' => !empty($_POST['status']) ? 1 : 0,
		);

		$page_info['body'] = preg_replace('~\xc2\xa0~', ' ', $page_info['body']);
		$page_info['ignores'] = preg_replace('/[^A-Za-z0-9,_~|]/', '', $page_info['ignores']);

		$smcFunc['db_query']('','
			DELETE FROM {db_prefix}sp_website_header
			WHERE id_head = {int:id}',
			array(
				'id' => 1,
			)
		);

		$smcFunc['db_insert']('',
			'{db_prefix}sp_website_header',
			$fields,
			$page_info,
			array('id_head')
		);

		redirectexit('action=admin;area=portalheader');
	}

	$_REQUEST['page_id'] = 1;
	$request = $smcFunc['db_query']('','
		SELECT id_head, body, ignores, status
		FROM {db_prefix}sp_website_header
		WHERE id_head = 1',
		array(
		)
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$context['SPortal']['header'] = array(
			'id' => 1,
			'body' => $row['body'],
			'ignores' => $row['ignores'],
			'status' => $row['status'],
		);
		$context['SPortal']['is_new'] = false;
	}
	$smcFunc['db_free_result']($request);

	$context['header_title'] = $context['SPortal']['is_new'] ? $txt['sp_admin_header_add'] : $txt['sp_admin_header_edit'];
	$context['sub_template'] = 'header_edit';
}


function sportal_admin_header_status()
{
	global $smcFunc;

	checkSession('get');

	$page_id = !empty($_REQUEST['page_id']) ? (int) $_REQUEST['page_id'] : 0;

	$smcFunc['db_query']('', '
		UPDATE {db_prefix}sp_website_header
		SET status = CASE WHEN status = {int:is_active} THEN 0 ELSE 1 END
		WHERE id_head = {int:id}',
		array(
			'is_active' => 1,
			'id' => 1,
		)
	);

	redirectexit('action=admin;area=portalheader');
}

?>